Index: issm/trunk/src/m/classes/model.m
===================================================================
--- issm/trunk/src/m/classes/model.m	(revision 25994)
+++ issm/trunk/src/m/classes/model.m	(revision 26744)
@@ -39,15 +39,15 @@
 		steadystate      = 0;
 		transient        = 0;
-		levelset			  = 0;
+		levelset         = 0;
 		calving          = 0;
 		frontalforcings  = 0;
-		love			     = 0;
-		gia				  = 0;
+		love             = 0;
 		esa              = 0;
+		sampling         = 0;
 
 		autodiff         = 0;
 		inversion        = 0;
 		qmu              = 0;
-		amr				 = 0;
+		amr              = 0;
 		results          = 0;
 		outputdefinition = 0;
@@ -55,4 +55,5 @@
 		miscellaneous    = 0;
 		private          = 0;
+		stochasticforcing= 0;
 
 		%}}}
@@ -133,6 +134,4 @@
 				end
 			end
-			%2017 April 10th
-			if isa(md.gia,'gia'), md.gia=giamme(); end
 			%2017 May 4th
 			if isa(md.amr,'double'); md.amr=amr(); end
@@ -156,5 +155,5 @@
 			if isa(md.frontalforcings,'double');
 				if(isprop('meltingrate',md.calving) & ~isnan(md.calving.meltingrate))
-					disp('Warning: md.calving.meltingrate is now in md.frontalforcings');
+		gia			disp('Warning: md.calving.meltingrate is now in md.frontalforcings');
 				end
 				md.frontalforcings=frontalforcings(md.calving); 
@@ -168,14 +167,17 @@
 				end
 			end
-			%2019 Mar 28
+			%2019 Mar 28, updated 2021 April 23
 			if isa(md.smb,'SMBcomponents') | isa(md.smb,'SMBmeltcomponents') | isa(md.smb,'SMBforcing') | isa(md.smb,'SMBgemb') 
-				if isa(md.smb.isclimatology,'double')
-					if prod(size(md.smb.isclimatology)) ~= 1
-						md.smb.isclimatology = 0;
+				if any(strcmp(fieldnames(md.smb),'isclimatology'))
+					if isa(md.smb.isclimatology,'double')
+						if prod(size(md.smb.isclimatology)) ~= 1
+							md.smb.isclimatology = 0;
+						end
+						md.timestepping.cycle_forcing=md.smb.isclimatology;
 					end
 				end
 			end
 			%2019 Dec 16
-			if isa(md.dsl,'double') | isempty(md.dsl.compute_fingerprints)
+			if isa(md.dsl,'double') 
 				md.dsl=dsl();
 			end
@@ -188,4 +190,8 @@
 				end
 			end
+			%2021 February 17
+			if isa(md.sampling,'double'); md.sampling=sampling(); end
+			%VV
+			if ~isa(md.stochasticforcing,'stochasticforcing'); md.stochasticforcing=stochasticforcing(); end
 		end% }}}
 	end
@@ -204,4 +210,49 @@
 		end
 		%}}}
+		function disp(self) % {{{
+			disp(sprintf('%19s: %-22s -- %s','mesh'            ,['[1x1 ' class(self.mesh) ']'],'mesh properties'));
+			disp(sprintf('%19s: %-22s -- %s','mask'            ,['[1x1 ' class(self.mask) ']'],'defines grounded and floating elements'));
+			disp(sprintf('%19s: %-22s -- %s','geometry'        ,['[1x1 ' class(self.geometry) ']'],'surface elevation, bedrock topography, ice thickness,...'));
+			disp(sprintf('%19s: %-22s -- %s','constants'       ,['[1x1 ' class(self.constants) ']'],'physical constants'));
+			disp(sprintf('%19s: %-22s -- %s','smb'             ,['[1x1 ' class(self.smb) ']'],'surface mass balance'));
+			disp(sprintf('%19s: %-22s -- %s','basalforcings'   ,['[1x1 ' class(self.basalforcings) ']'],'bed forcings'));
+			disp(sprintf('%19s: %-22s -- %s','materials'       ,['[1x1 ' class(self.materials) ']'],'material properties'));
+			disp(sprintf('%19s: %-22s -- %s','damage'          ,['[1x1 ' class(self.damage) ']'],'parameters for damage evolution solution'));
+			disp(sprintf('%19s: %-22s -- %s','friction'        ,['[1x1 ' class(self.friction) ']'],'basal friction/drag properties'));
+			disp(sprintf('%19s: %-22s -- %s','flowequation'    ,['[1x1 ' class(self.flowequation) ']'],'flow equations'));
+			disp(sprintf('%19s: %-22s -- %s','timestepping'    ,['[1x1 ' class(self.timestepping) ']'],'time stepping for transient models'));
+			disp(sprintf('%19s: %-22s -- %s','initialization'  ,['[1x1 ' class(self.initialization) ']'],'initial guess/state'));
+			disp(sprintf('%19s: %-22s -- %s','rifts'           ,['[1x1 ' class(self.rifts) ']'],'rifts properties'));
+			disp(sprintf('%19s: %-22s -- %s','solidearth'      ,['[1x1 ' class(self.solidearth) ']'],'solidearth inputs and settings'));
+			disp(sprintf('%19s: %-22s -- %s','dsl'             ,['[1x1 ' class(self.dsl) ']'],'dynamic sea-level '));
+			disp(sprintf('%19s: %-22s -- %s','debug'           ,['[1x1 ' class(self.debug) ']'],'debugging tools (valgrind, gprof)'));
+			disp(sprintf('%19s: %-22s -- %s','verbose'         ,['[1x1 ' class(self.verbose) ']'],'verbosity level in solve'));
+			disp(sprintf('%19s: %-22s -- %s','settings'        ,['[1x1 ' class(self.settings) ']'],'settings properties'));
+			disp(sprintf('%19s: %-22s -- %s','toolkits'        ,['[1x1 ' class(self.toolkits) ']'],'PETSc options for each solution'));
+			disp(sprintf('%19s: %-22s -- %s','cluster'         ,['[1x1 ' class(self.cluster) ']'],'cluster parameters (number of CPUs...)'));
+			disp(sprintf('%19s: %-22s -- %s','balancethickness',['[1x1 ' class(self.balancethickness) ']'],'parameters for balancethickness solution'));
+			disp(sprintf('%19s: %-22s -- %s','stressbalance'   ,['[1x1 ' class(self.stressbalance) ']'],'parameters for stressbalance solution'));
+			disp(sprintf('%19s: %-22s -- %s','groundingline'   ,['[1x1 ' class(self.groundingline) ']'],'parameters for groundingline solution'));
+			disp(sprintf('%19s: %-22s -- %s','hydrology'       ,['[1x1 ' class(self.hydrology) ']'],'parameters for hydrology solution'));
+			disp(sprintf('%19s: %-22s -- %s','masstransport'   ,['[1x1 ' class(self.masstransport) ']'],'parameters for masstransport solution'));
+			disp(sprintf('%19s: %-22s -- %s','thermal'         ,['[1x1 ' class(self.thermal) ']'],'parameters for thermal solution'));
+			disp(sprintf('%19s: %-22s -- %s','steadystate'     ,['[1x1 ' class(self.steadystate) ']'],'parameters for steadystate solution'));
+			disp(sprintf('%19s: %-22s -- %s','transient'       ,['[1x1 ' class(self.transient) ']'],'parameters for transient solution'));
+			disp(sprintf('%19s: %-22s -- %s','levelset'        ,['[1x1 ' class(self.levelset) ']'],'parameters for moving boundaries (level-set method)'));
+			disp(sprintf('%19s: %-22s -- %s','calving'         ,['[1x1 ' class(self.calving) ']'],'parameters for calving'));
+			disp(sprintf('%19s: %-22s -- %s','frontalforcings' ,['[1x1 ' class(self.frontalforcings) ']'],'parameters for frontalforcings'));
+			disp(sprintf('%19s: %-22s -- %s','esa'             ,['[1x1 ' class(self.esa) ']'],'parameters for elastic adjustment solution'));
+			disp(sprintf('%19s: %-22s -- %s','love'            ,['[1x1 ' class(self.love) ']'],'parameters for love solution'));
+			disp(sprintf('%19s: %-22s -- %s','sampling'        ,['[1x1 ' class(self.sampling) ']'],'parameters for stochastic sampler'));
+			disp(sprintf('%19s: %-22s -- %s','autodiff'        ,['[1x1 ' class(self.autodiff) ']'],'automatic differentiation parameters'));
+			disp(sprintf('%19s: %-22s -- %s','inversion'       ,['[1x1 ' class(self.inversion) ']'],'parameters for inverse methods'));
+			disp(sprintf('%19s: %-22s -- %s','qmu'             ,['[1x1 ' class(self.qmu) ']'],'Dakota properties'));
+			disp(sprintf('%19s: %-22s -- %s','amr'             ,['[1x1 ' class(self.amr) ']'],'adaptive mesh refinement properties'));
+			disp(sprintf('%19s: %-22s -- %s','outputdefinition',['[1x1 ' class(self.outputdefinition) ']'],'output definition'));
+			disp(sprintf('%19s: %-22s -- %s','results'         ,['[1x1 ' class(self.results) ']'],'model results'));
+			disp(sprintf('%19s: %-22s -- %s','radaroverlay'    ,['[1x1 ' class(self.radaroverlay) ']'],'radar image for plot overlay'));
+			disp(sprintf('%19s: %-22s -- %s','miscellaneous'   ,['[1x1 ' class(self.miscellaneous) ']'],'miscellaneous fields'));
+			disp(sprintf('%19s: %-22s -- %s','stochasticforcing',['[1x1 ' class(self.stochasticforcing) ']'],'stochasticity applied to model forcings'));
+		end % }}}
 		function md = setdefaultparameters(md,planet) % {{{
 
@@ -238,7 +289,7 @@
 			md.calving          = calving();
 			md.frontalforcings  = frontalforcings();
-			md.gia              = giamme();
 			md.love             = fourierlove();
 			md.esa              = esa();
+			md.sampling         = sampling();
 			md.autodiff         = autodiff();
 			md.inversion        = inversion();
@@ -250,4 +301,5 @@
 			md.miscellaneous    = miscellaneous();
 			md.private          = private();
+			md.stochasticforcing= stochasticforcing();
 		end
 		%}}}
@@ -304,4 +356,7 @@
 				md.friction.C=project2d(md,md.friction.C,1);
 				md.friction.m=project2d(md,md.friction.m,1);
+			elseif isa(md.friction,'frictionjosh'),
+				md.friction.coefficient=project2d(md,md.friction.coefficient,1);
+				md.friction.pressure_adjusted_temperature=project2d(md,md.friction.pressure_adjusted_temperature,1);
 			else
 				disp('friction type not supported');
@@ -371,9 +426,4 @@
 			end
 
-			%giaivins
-			if isa(md.gia,'giaivins'),
-				if ~isnan(md.gia.mantle_viscosity), md.gia.mantle_viscosity=project2d(md,md.gia.mantle_viscosity,1); end
-				if ~isnan(md.gia.lithosphere_thickness), md.gia.lithosphere_thickness=project2d(md,md.gia.lithosphere_thickness,1); end
-			end
 
 			%elementstype
@@ -417,4 +467,7 @@
 			md.materials.rheology_B=DepthAverage(md,md.materials.rheology_B);
 			md.materials.rheology_n=project2d(md,md.materials.rheology_n,1);
+			if isprop(md.materials,'rheology_E')
+				md.materials.rheology_E=project2d(md,md.materials.rheology_E,1);
+			end
 			
 			%damage: 
@@ -615,6 +668,6 @@
 						elseif fieldsize(1)==numberofelements1
 							md2.(model_fields{i}).(object_fields{j})=field(pos_elem,:);
-                        elseif (fieldsize(1)==numberofelements1+1)
-                            md2.(model_fields{i}).(object_fields{j})=[field(pos_elem,:); field(end,:)];
+						elseif (fieldsize(1)==numberofelements1+1)
+							md2.(model_fields{i}).(object_fields{j})=[field(pos_elem,:); field(end,:)];
 						end
 					end
@@ -628,5 +681,5 @@
 					elseif fieldsize(1)==numberofelements1
 						md2.(model_fields{i})=field(pos_elem,:);
-                    elseif (fieldsize(1)==numberofelements1+1)
+					elseif (fieldsize(1)==numberofelements1+1)
 						md2.(model_fields{i})=[field(pos_elem,:); field(end,:)];
 					end
@@ -775,16 +828,16 @@
 						% loop over time steps
 						for p=1:length(md1.results.(solutionfields{i}))
-						    current = md1.results.(solutionfields{i})(p);
-						    solutionsubfields=fields(current);
-						    for j=1:length(solutionsubfields),
+							current = md1.results.(solutionfields{i})(p);
+							solutionsubfields=fields(current);
+							for j=1:length(solutionsubfields),
 							field=md1.results.(solutionfields{i})(p).(solutionsubfields{j});
 							if length(field)==numberofvertices1,
-							    md2.results.(solutionfields{i})(p).(solutionsubfields{j})=field(pos_node);
+								md2.results.(solutionfields{i})(p).(solutionsubfields{j})=field(pos_node);
 							elseif length(field)==numberofelements1,
-							    md2.results.(solutionfields{i})(p).(solutionsubfields{j})=field(pos_elem);
+								md2.results.(solutionfields{i})(p).(solutionsubfields{j})=field(pos_elem);
 							else
-							    md2.results.(solutionfields{i})(p).(solutionsubfields{j})=field;
+								md2.results.(solutionfields{i})(p).(solutionsubfields{j})=field;
 							end
-						    end
+							end
 						end
 					else
@@ -820,4 +873,126 @@
 			md2.mesh.extractedvertices=pos_node;
 			md2.mesh.extractedelements=pos_elem;
+		end % }}}
+		function md2 = refine(md) % {{{
+			%refine - split all triangles into 3 to refine the mesh everywhere
+			%
+			%   This function only works for 2d triangle meshes
+			%
+			%   Usage:
+			%      md2=refine(md);
+			%
+			%   See also: EXTRUDE, COLLAPSE, EXTRACT
+
+			%Check incoming 
+			if ~strcmp(elementtype(md.mesh),'Tria')
+				error('not supported for 3d meshes');
+			end
+
+			%copy model
+			md2=md;
+
+			disp('Getting edges');
+			%initialization of some variables
+			nbe   = md.mesh.numberofelements;
+			nbv   = md.mesh.numberofvertices;
+			index = md.mesh.elements;
+			elementslist=1:nbe;
+			%1: list of edges
+			edges=[index(:,[1,2]); index(:,[2,3]); index(:,[3,1])];
+			%2: find unique edges
+			[edges,I,J]=unique(sort(edges,2),'rows');
+			%3: unique edge numbers
+			vec=J;
+			%4: unique edges numbers in each triangle (2 triangles sharing the same edge will have the same edge number)
+			edges_tria=[vec(elementslist+nbe) vec(elementslist+2*nbe) vec(elementslist)];
+
+			% We divide each element as follows
+			%
+			%                   e2
+			%    n1 ------------+------------ n3
+			%       \          / \          /
+			%        \    1   /   \   3    /
+			%         \      /     \      /
+			%          \    /   2   \    /
+			%           \  /         \  /
+			%         e3 +____________\/ e1
+			%             \           /
+			%              \         /
+			%               \   4   /
+			%                \     /
+			%                 \   /
+			%                   n2
+
+			%Create new coordinates
+			disp('Remeshing...');
+			x_edges = 0.5*(md.mesh.x(edges(:,1)) + md.mesh.x(edges(:,2)));
+			y_edges = 0.5*(md.mesh.y(edges(:,1)) + md.mesh.y(edges(:,2)));
+			md2.mesh.x = [md2.mesh.x;x_edges];
+			md2.mesh.y = [md2.mesh.y;y_edges];
+			md2.mesh.elements = [...
+				index(:,1)          nbv+edges_tria(:,3) nbv+edges_tria(:,2);...
+				nbv+edges_tria(:,2) nbv+edges_tria(:,3) nbv+edges_tria(:,1);...
+				nbv+edges_tria(:,2) nbv+edges_tria(:,1) index(:,3);...
+				nbv+edges_tria(:,3) index(:,2)          nbv+edges_tria(:,1)];
+			md2.mesh.numberofelements = 4*nbe;
+			md2.mesh.numberofvertices = nbv + size(edges,1);
+			disp(['   Old number of elements: ' num2str(nbe)]);
+			disp(['   New number of elements: ' num2str(4*nbe)]);
+
+			disp('Interpolate all fields');
+			numberofvertices1 = md.mesh.numberofvertices;
+			numberofelements1 = md.mesh.numberofelements;
+			nbv2 = md2.mesh.numberofvertices;
+
+			%Create transformation vectors
+			nbedges = size(edges,1);
+			Pelem = sparse(1:4*nbe,repmat([1:nbe],1,4),ones(4*nbe,1),4*nbe,nbe);
+			Pnode = sparse([1:nbv,repmat([nbv+1:nbv+nbedges],1,2)],[1:nbv edges(:)'],[ones(nbv,1);1/2*ones(2*nbedges,1)],md2.mesh.numberofvertices,nbv);
+
+			%Deal with mesh
+			if numel(md.mesh.scale_factor)==md.mesh.numberofvertices
+				md2.mesh.scale_factor=Pnode*md.mesh.scale_factor;
+			end
+
+			%loop over model fields
+			model_fields=setxor(fields(md),{'mesh'});
+			%remove mesh from this field
+			for i=1:length(model_fields),
+				%get field
+				field=md.(model_fields{i});
+				fieldsize=size(field);
+				if isobject(field), %recursive call
+					object_fields=fields(md.(model_fields{i}));
+					for j=1:length(object_fields),
+						%get field
+						field=md.(model_fields{i}).(object_fields{j});
+						fieldsize=size(field);
+						%size = number of nodes * n
+						if fieldsize(1)==numberofvertices1
+							md2.(model_fields{i}).(object_fields{j})=Pnode*field;
+						elseif (fieldsize(1)==numberofvertices1+1)
+							md2.(model_fields{i}).(object_fields{j})=[Pnode*field(1:end-1,:); field(end,:)];
+							%size = number of elements * n
+						elseif fieldsize(1)==numberofelements1
+							md2.(model_fields{i}).(object_fields{j})=Pelem*field;
+						elseif (fieldsize(1)==numberofelements1+1)
+							md2.(model_fields{i}).(object_fields{j})=[Pelem*field(1:end-1,:); field(end,:)];
+						end
+					end
+				else
+					%size = number of nodes * n
+					if fieldsize(1)==numberofvertices1
+						md2.(model_fields{i})=Pnode*field;
+					elseif (fieldsize(1)==numberofvertices1+1)
+						md2.(model_fields{i})=[Pnode*field(1:end-1,:); field(end,:)];
+						%size = number of elements * n
+					elseif fieldsize(1)==numberofelements1
+						md2.(model_fields{i})=Pelem*field;
+					elseif (fieldsize(1)==numberofelements1+1)
+						md2.(model_fields{i})=[Pelem*field(1:end-1,:); field(end,:)];
+					end
+				end
+			end
+
 		end % }}}
 		function md = extrude(md,varargin) % {{{
@@ -1017,5 +1192,5 @@
 				md.mesh.average_vertex_connectivity=100;
 			end
-			end % }}}
+		end % }}}
 		function md = structtomodel(md,structmd) % {{{
 
@@ -1300,5 +1475,6 @@
 				md.smb=SMBhenning(structmd.surfaceforcings);
 			end
-			if isfield(structmd,'slr'),
+			if isfield(structmd,'slr') && ~isempty(structmd.slr)
+				md.solidearth       = solidearth('Earth');
 				disp('Recovering old slr class');
 				if isfield(structmd.slr,'sealevel'),
@@ -1467,95 +1643,52 @@
 			end
 		end % }}}
-		function disp(self) % {{{
-			disp(sprintf('%19s: %-22s -- %s','mesh'            ,['[1x1 ' class(self.mesh) ']'],'mesh properties'));
-			disp(sprintf('%19s: %-22s -- %s','mask'            ,['[1x1 ' class(self.mask) ']'],'defines grounded and floating elements'));
-			disp(sprintf('%19s: %-22s -- %s','geometry'        ,['[1x1 ' class(self.geometry) ']'],'surface elevation, bedrock topography, ice thickness,...'));
-			disp(sprintf('%19s: %-22s -- %s','constants'       ,['[1x1 ' class(self.constants) ']'],'physical constants'));
-			disp(sprintf('%19s: %-22s -- %s','smb'             ,['[1x1 ' class(self.smb) ']'],'surface mass balance'));
-			disp(sprintf('%19s: %-22s -- %s','basalforcings'   ,['[1x1 ' class(self.basalforcings) ']'],'bed forcings'));
-			disp(sprintf('%19s: %-22s -- %s','materials'       ,['[1x1 ' class(self.materials) ']'],'material properties'));
-			disp(sprintf('%19s: %-22s -- %s','damage'          ,['[1x1 ' class(self.damage) ']'],'parameters for damage evolution solution'));
-			disp(sprintf('%19s: %-22s -- %s','friction'        ,['[1x1 ' class(self.friction) ']'],'basal friction/drag properties'));
-			disp(sprintf('%19s: %-22s -- %s','flowequation'    ,['[1x1 ' class(self.flowequation) ']'],'flow equations'));
-			disp(sprintf('%19s: %-22s -- %s','timestepping'    ,['[1x1 ' class(self.timestepping) ']'],'time stepping for transient models'));
-			disp(sprintf('%19s: %-22s -- %s','initialization'  ,['[1x1 ' class(self.initialization) ']'],'initial guess/state'));
-			disp(sprintf('%19s: %-22s -- %s','rifts'           ,['[1x1 ' class(self.rifts) ']'],'rifts properties'));
-			disp(sprintf('%19s: %-22s -- %s','solidearth'      ,['[1x1 ' class(self.solidearth) ']'],'solidearth inputs and settings'));
-			disp(sprintf('%19s: %-22s -- %s','dsl'             ,['[1x1 ' class(self.dsl) ']'],'dynamic sea-level '));
-			disp(sprintf('%19s: %-22s -- %s','debug'           ,['[1x1 ' class(self.debug) ']'],'debugging tools (valgrind, gprof)'));
-			disp(sprintf('%19s: %-22s -- %s','verbose'         ,['[1x1 ' class(self.verbose) ']'],'verbosity level in solve'));
-			disp(sprintf('%19s: %-22s -- %s','settings'        ,['[1x1 ' class(self.settings) ']'],'settings properties'));
-			disp(sprintf('%19s: %-22s -- %s','toolkits'        ,['[1x1 ' class(self.toolkits) ']'],'PETSc options for each solution'));
-			disp(sprintf('%19s: %-22s -- %s','cluster'         ,['[1x1 ' class(self.cluster) ']'],'cluster parameters (number of cpus...)'));
-			disp(sprintf('%19s: %-22s -- %s','balancethickness',['[1x1 ' class(self.balancethickness) ']'],'parameters for balancethickness solution'));
-			disp(sprintf('%19s: %-22s -- %s','stressbalance'   ,['[1x1 ' class(self.stressbalance) ']'],'parameters for stressbalance solution'));
-			disp(sprintf('%19s: %-22s -- %s','groundingline'   ,['[1x1 ' class(self.groundingline) ']'],'parameters for groundingline solution'));
-			disp(sprintf('%19s: %-22s -- %s','hydrology'       ,['[1x1 ' class(self.hydrology) ']'],'parameters for hydrology solution'));
-			disp(sprintf('%19s: %-22s -- %s','masstransport'   ,['[1x1 ' class(self.masstransport) ']'],'parameters for masstransport solution'));
-			disp(sprintf('%19s: %-22s -- %s','thermal'         ,['[1x1 ' class(self.thermal) ']'],'parameters for thermal solution'));
-			disp(sprintf('%19s: %-22s -- %s','steadystate'     ,['[1x1 ' class(self.steadystate) ']'],'parameters for steadystate solution'));
-			disp(sprintf('%19s: %-22s -- %s','transient'       ,['[1x1 ' class(self.transient) ']'],'parameters for transient solution'));
-			disp(sprintf('%19s: %-22s -- %s','levelset'        ,['[1x1 ' class(self.levelset) ']'],'parameters for moving boundaries (level-set method)'));
-			disp(sprintf('%19s: %-22s -- %s','calving'         ,['[1x1 ' class(self.calving) ']'],'parameters for calving'));
-			disp(sprintf('%19s: %-22s -- %s','frontalforcings' ,['[1x1 ' class(self.frontalforcings) ']'],'parameters for frontalforcings'));
-			disp(sprintf('%19s: %-22s -- %s','gia'             ,['[1x1 ' class(self.gia) ']'],'parameters for gia solution'));
-			disp(sprintf('%19s: %-22s -- %s','esa'             ,['[1x1 ' class(self.esa) ']'],'parameters for elastic adjustment solution'));
-			disp(sprintf('%19s: %-22s -- %s','love'            ,['[1x1 ' class(self.love) ']'],'parameters for love solution'));
-			disp(sprintf('%19s: %-22s -- %s','autodiff'        ,['[1x1 ' class(self.autodiff) ']'],'automatic differentiation parameters'));
-			disp(sprintf('%19s: %-22s -- %s','inversion'       ,['[1x1 ' class(self.inversion) ']'],'parameters for inverse methods'));
-			disp(sprintf('%19s: %-22s -- %s','qmu'             ,['[1x1 ' class(self.qmu) ']'],'dakota properties'));
-			disp(sprintf('%19s: %-22s -- %s','amr'             ,['[1x1 ' class(self.amr) ']'],'adaptive mesh refinement properties'));
-			disp(sprintf('%19s: %-22s -- %s','outputdefinition',['[1x1 ' class(self.outputdefinition) ']'],'output definition'));
-			disp(sprintf('%19s: %-22s -- %s','results'         ,['[1x1 ' class(self.results) ']'],'model results'));
-			disp(sprintf('%19s: %-22s -- %s','radaroverlay'    ,['[1x1 ' class(self.radaroverlay) ']'],'radar image for plot overlay'));
-			disp(sprintf('%19s: %-22s -- %s','miscellaneous'   ,['[1x1 ' class(self.miscellaneous) ']'],'miscellaneous fields'));
-		end % }}}
 		function memory(self) % {{{
 
-		disp(sprintf('\nMemory imprint:\n'));
-
-		fields=properties('model');
-		mem=0;
-
-		for i=1:length(fields),
-			field=self.(fields{i});
-			s=whos('field'); 
-			mem=mem+s.bytes/1e6;
-			disp(sprintf('%19s: %6.2f Mb',fields{i},s.bytes/1e6));
+			disp(sprintf('\nMemory imprint:\n'));
+
+			fields=properties('model');
+			mem=0;
+
+			for i=1:length(fields),
+				field=self.(fields{i});
+				s=whos('field'); 
+				mem=mem+s.bytes/1e6;
+				disp(sprintf('%19s: %6.2f Mb',fields{i},s.bytes/1e6));
+			end
+			disp(sprintf('%19s--%10s','--------------','--------------'));
+			disp(sprintf('%19s: %g Mb','Total',mem));
 		end
-		disp(sprintf('%19s--%10s','--------------','--------------'));
-		disp(sprintf('%19s: %g Mb','Total',mem));
-		end % }}}
+		% }}}
 		function netcdf(self,filename) % {{{
-		%NETCDF - save model as netcdf
-		%
-		%   Usage:
-		%      netcdf(md,filename)
-		%
-		%   Example:
-		%      netcdf(md,'model.nc');
-
-		disp('Saving model as NetCDF');
-		%1. Create NetCDF file
-		ncid=netcdf.create(filename,'CLOBBER');
-		netcdf.putAtt(ncid,netcdf.getConstant('NC_GLOBAL'),'Conventions','CF-1.4');
-		netcdf.putAtt(ncid,netcdf.getConstant('NC_GLOBAL'),'Title',['ISSM model (' self.miscellaneous.name ')']);
-		netcdf.putAtt(ncid,netcdf.getConstant('NC_GLOBAL'),'Author',getenv('USER'));
-		netcdf.putAtt(ncid,netcdf.getConstant('NC_GLOBAL'),'Date',datestr(now));
-
-		%Preallocate variable id, needed to write variables in netcdf file
-		var_id=zeros(1000,1);%preallocate
-
-		for step=1:2,
-			counter=0;
-			[var_id,counter]=structtonc(ncid,'md',self,0,var_id,counter,step);
-			if step==1, netcdf.endDef(ncid); end
-		end
-
-		if counter>1000,
-			warning(['preallocation of var_id need to be updated from ' num2str(1000) ' to ' num2str(counter)]);
-		end
-
-		netcdf.close(ncid)
+			%NETCDF - save model as netcdf
+			%
+			%   Usage:
+			%      netcdf(md,filename)
+			%
+			%   Example:
+			%      netcdf(md,'model.nc');
+
+			disp('Saving model as NetCDF');
+			%1. Create NetCDF file
+			ncid=netcdf.create(filename,'CLOBBER');
+			netcdf.putAtt(ncid,netcdf.getConstant('NC_GLOBAL'),'Conventions','CF-1.4');
+			netcdf.putAtt(ncid,netcdf.getConstant('NC_GLOBAL'),'Title',['ISSM model (' self.miscellaneous.name ')']);
+			netcdf.putAtt(ncid,netcdf.getConstant('NC_GLOBAL'),'Author',getenv('USER'));
+			netcdf.putAtt(ncid,netcdf.getConstant('NC_GLOBAL'),'Date',datestr(now));
+
+			%Preallocate variable id, needed to write variables in netcdf file
+			var_id=zeros(1000,1);%preallocate
+
+			for step=1:2,
+				counter=0;
+				[var_id,counter]=structtonc(ncid,'md',self,0,var_id,counter,step);
+				if step==1, netcdf.endDef(ncid); end
+			end
+
+			if counter>1000,
+				warning(['preallocation of var_id need to be updated from ' num2str(1000) ' to ' num2str(counter)]);
+			end
+
+			netcdf.close(ncid)
 		end % }}}
 		function xylim(self) % {{{
@@ -1565,38 +1698,38 @@
 		end % }}}
 		function md=upload(md) % {{{
-		%the goal of this routine is to upload the model onto a server, and to empty it.
-		%So first, save the model with a unique name and upload the file to the server: 
-		random_part=fix(rand(1)*10000);
-		id=[md.miscellaneous.name '-' regexprep(datestr(now),'[^\w'']','') '-' num2str(random_part)  '-' getenv('USER') '-' oshostname() '.upload']; 
-		eval(['save ' id ' md']);
-
-		%Now, upload the file: 
-		issmscpout(md.settings.upload_server,md.settings.upload_path,md.settings.upload_login,md.settings.upload_port,{id},1);
-
-		%Now, empty this model of everything except settings, and record name of file we just uploaded!
-		settings_back=md.settings;
-		md=model();
-		md.settings=settings_back;
-		md.settings.upload_filename=id;
-
-		%get locally rid of file that was uploaded
-		eval(['delete ' id]);
+			%the goal of this routine is to upload the model onto a server, and to empty it.
+			%So first, save the model with a unique name and upload the file to the server: 
+			random_part=fix(rand(1)*10000);
+			id=[md.miscellaneous.name '-' regexprep(datestr(now),'[^\w'']','') '-' num2str(random_part)  '-' getenv('USER') '-' oshostname() '.upload']; 
+			eval(['save ' id ' md']);
+
+			%Now, upload the file: 
+			issmscpout(md.settings.upload_server,md.settings.upload_path,md.settings.upload_login,md.settings.upload_port,{id},1);
+
+			%Now, empty this model of everything except settings, and record name of file we just uploaded!
+			settings_back=md.settings;
+			md=model();
+			md.settings=settings_back;
+			md.settings.upload_filename=id;
+
+			%get locally rid of file that was uploaded
+			eval(['delete ' id]);
 
 		end % }}}
 		function md=download(md) % {{{
 
-		%the goal of this routine is to download the internals of the current model from a server, because 
-		%this model is empty, except for the settings which tell us where to go and find this model!
-
-		%Download the file: 
-		issmscpin(md.settings.upload_server, md.settings.upload_login, md.settings.upload_port, md.settings.upload_path, {md.settings.upload_filename});
-
-		name=md.settings.upload_filename;
-
-		%Now, load this model: 
-		md=loadmodel(md.settings.upload_filename);
-
-		%get locally rid of file that was downloaded
-		eval(['delete ' name]);
+			%the goal of this routine is to download the internals of the current model from a server, because 
+			%this model is empty, except for the settings which tell us where to go and find this model!
+
+			%Download the file: 
+			issmscpin(md.settings.upload_server, md.settings.upload_login, md.settings.upload_port, md.settings.upload_path, {md.settings.upload_filename});
+
+			name=md.settings.upload_filename;
+
+			%Now, load this model: 
+			md=loadmodel(md.settings.upload_filename);
+
+			%get locally rid of file that was downloaded
+			eval(['delete ' name]);
 
 		end % }}}
